package com.huimv.manage.util;

import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import sun.misc.BASE64Decoder;

import java.io.IOException;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
public class CodeUtil {
    @Autowired
    private HexUtils hexUtils;

    /**
     * @Method      : convertBase64BinaryToHex
     * @Description : 对Base64Binary类型的数据进行转换成16进制数
     * @Params      : [encodeText]
     * @Return      : java.lang.String
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/11/5       
     * @Time        : 14:46
     */
    public String convertBase64BinaryToHex(String encodeText) throws IOException {
        if(encodeText == null || StringUtils.isEmpty(encodeText)) {
            return "";
        }
        BASE64Decoder decode = new BASE64Decoder();
        //base64反向解码
        byte[] d1 = decode.decodeBuffer(encodeText);
        //将二进制转换成16进制
        return hexUtils.parseByte2HexStr(d1).toLowerCase();
    }
}
